Build 3.4.00.0 (release)


IMPROVED IMAGE SAVING

Bit depth (8 or 16 bit) and compression options (None/LZW/Zip) are now available for TIFFs that are created by Render Sequence and Render All To Disk. The options are chosen with the "TIFF Options" button on the Sequence/Output tab of the render node. They apply to the main image output, RGB render element and Alpha render element (all other render elements are forced to be EXR at the moment so it doesn't apply to them). Images saved manually from the Render View continue to use separate settings which are chosen when saving the image.

Alpha images saved as 16-bit TIFFs are no longer tone mapped (but they are still gamma corrected).

The default image format for output filenames on the render node is now .tif instead of .bmp.

When forcing render elements to be EXR (all elements except Rgb and Alpha), any existing extension is removed before adding .exr to the filename so that you don't end up with a double extension such as ".tif.exr" or ".bmp.exr".


IMPROVED OBJ SUPPORT

OBJ Reader reads map_d (opacity texture) from .mtl files. This only affects the first time the OBJ Reader is created (e.g. when adding from a menu).

OBJ Reader reads Ni (index of refraction) from .mtl files. This only affects the first time the OBJ Reader is created (e.g. when adding from a menu).

OBJ Reader's .mtl reader trims whitespace from the beginning of lines before parsing. This allows correct reading of some files that didn't work before.


OTHER CHANGES

Prevented a crash when calculating populations and possibly other situations too.

Prevented a crash that could occur with separate shader previews of shaders that are disconnected from the rest of the node network.

Windows only: Fixed a problem that would sometimes hang the program after the computer woke up from sleep mode.

Windows only: Fixed a problem that would cause the main window to go behind another window when closing the colour picker, TIFF options dialog or other modal dialog.

"Unpremult colour" is now turned off by default in the Default Shader and Image Map Shader.

Previously, in non-animation editions (including the free edition) the camera node's depth-of-field parameters were being shown below the "General" tab. They are now shown on the "Blur" tab as they are in animation-enabled editions.


Build 3.3.04.0 (release)


Fixed a bug with relative paths to GI cache files.

New shader: Shadow Catcher Shader.


Build 3.3.03.0 (release)


Per-object "render method" parameter, choosing between "Default", "Force Displacement" and "Force Ray Trace". When this is set to "Default", it is rendered according to the "Ray trace objects" setting in the render node.

Mac (64-bit) and Linux only: Reduced memory consumption of objects and populations.

If the Render View is closed and then reopened at any time, it opens with the most recently-rendered image, and the image can be saved. Previously the image would be lost when closing the Render View.

Fixed bug #590, which caused the Save button on the Render View to save the wrong image (or no image at all) if the current render node is different from the render node that create the image.

TCB values (tension, continuity, bias) for animation keys can now be edited in the animation view's curve editor.

Mac only: Turned on high resolution mode so the user interface looks better on Retina displays. Button icons etc. and OpenGL views (3D preview, node network etc.) have not been updated for high resolution yet.

Probably fixed bug #456: Copy pasting a node caused populations to repopulate before rendering.

Possibly fixed bug #476: Unforced and mysterious population recalculations.

Fixed a problem that stopped some edited population instances from being editable after repopulating (e.g. after reloading the project).

Fixed a problem with edited instances in populations that had instances that were both modified and deleted.

Fixed Bug #634: When populating a Rock population, the progress dialog sometimes didn't show the Abort button.

Made lots of changes to stop 3D Previews from updating or aborting during some actions where they don't need to. In some cases the abort would make the interface feel sluggish during user input, and this has now improved. Some of the affected actions were: moving nodes, renaming nodes, copying/pasting/duplicating nodes. This also fixes bug #574.

Fixed problems that were causing the 3D Preview and shader/heightfield previews to restart multiple times when more than one preview was open.

A new "HD" button on 3D Preview and on shader/heightfield previews. This doubles the maximum detail, from 80 to 160 in normal 3D Previews, and from 160 to 320 in shader/heightfield previews.

Changed the layout of some buttons on the 3D Preview.

Camera paths in the 3D Preview now draw dots for any keyed parameters, not just keys on the position.

Fixed a bug which could lead to a crash when deleting some nodes.

Prevented the Image Map Shader from crashing when the size parameter becomes 0, which could happen while deleting numbers.

Fixed bug #633: Adding a preview image to a project item in the library caused a crash.

Made some improvements to the way project previews are handled when they're added to an open project file from the Library window.

Moved the following parameters from the render node to the render subdiv settings node: Displacement filter, Microvertex jittering, Detail jittering. To maintain forward and backward compatibility, they are still duplicated in the render node, but hidden from the GUI.

Fixed bug #631, which caused the surface depth render element to be incorrect with spherical cameras and fisheye lenses.

Added "-threads" command line argument to override the number of threads used for rendering, population, previews and any other multi-threaded tasks. Usage example: -threads 4

Changed how number-of-core overrides are reported to the console and the about/splash box.

Windows Installers are now digitally signed by Planetside Software LLC with a code signing certificate from Comodo CA.


Build 3.2.04.0 (release)


Fixed an issue with the Create Clip dialog which could cause a hang on the Mac.

Mac only: Fixed a problem which prevented v3.2.03.0 from running.


Build 3.2.03.0 (release)


Fixed a problem with the Reflective Shader and reflectivity in the Default Shader whenever we see a surface from the reverse side. This can happen with many objects, so we recommend that you get this update. The bug was introduced in 3.2.02.0. If you load a file that was saved in 3.2.02.0 you might see a warning about a missing parameter "double-sided surface" in the Reflective Shader, but the warning is harmless.


Build 3.2.02.0 (release)


CAMERAS

Stereoscopic camera options (only in Professional Edition and Professional with Animation). Stereoscopic camera options are found on the new "Stereo" tab of the camera node. Simply turn the camera into a stereo camera by enabling the "Stereo" checkbox and choosing "Left", "Centre" or "Right" camera to tell the renderer which viewpoint to use. You can choose between Parallel and Off Axis projection modes, and adjust the inter-axial separation (eye separation) and the distance to the zero parallax plane (the latter has no effect in Parallel mode). "Toe in" mode is not yet supported, but can always be achieved by manually rotating cameras or by importing separate Left and Right cameras from other software.

Stereo also works with spherical projection. This can render content for Virtual Reality and other panoramic stereoscopic 3D applications. Many popular renderers need special hacks or custom code to render panoramic stereocopic 3D because it is more complicated than simply rendering panoramas from two different camera positions, but Terragen now supports this natively.

Note: In this release the 3D Preview always views from the centre camera and there is no visual indication of the camera separation except by rendering an image. We plan to add stereo preview options in future versions.

To perceive the 3D effect of stereoscopic 3D renders you will need software that is capable of displaying stereoscopic 3D, which we do not currently provide.

Fisheye lens option. This is a sub-option of "perspective" mode in the camera node.

Camera motion blur settings now default to giving "centred" motion blur. There's a new "motion blur position" parameter added to the camera, with 4 choices: "Start on frame", "Centre on frame", "End on frame" and "Custom".

When importing cameras from FBX or chan files, Euler flips are automatically corrected.

Camera FBX import reports errors in some situations where it would previously fail silently.


RENDERING AND LIGHTING

Fixed a bug with Defer Atmo/Cloud which was causing two problems. The GI Surface Details effect was rendered incorrectly on areas of the image that were heavily occluded by cloud or atmosphere, and Render Elements had incorrect values which made it difficult composite them in an external compositor. Bug #589.

Fixed an undesirable grid-like noise pattern (and tiling artefact with certain settings) in motion blur or DOF when AA is something other than a power of 2. Non-power-of-2 AA numbers will now render motion blur and DOF much better than before, although power-of-2 AA still has the (possibly small) advantage of a more optimally distributed set of 4 initial motion blur samples. The tiling artefact would occur if using Defer Atmo or Ray Trace Objects combined with rasterised micropolygons, and was caused by the same thing that caused the grid pattern.

Sharp specular highlights and intense sun glow in atmosphere and clouds are no longer inhibited in reflections and refractions of lightDepth >= 3. Previously was being inhibited to help reduce variance in GI sampling, but only testing for lightDepth.

New shader: Glass Shader. This shader is a hybrid between the Water Shader and the Reflective Shader, with better defaults for rendering glass or similar-looking materials. The Glass Shader incorporates the same volume/sub-surface options that the Water Shader has. It also has a "double-sided surface" parameter to control whether the object's surface is treated as an infinitely thin volume without refraction instead of an interface into or out of a volume. You might turn this on for window panes, for example, or turn it off for gemstones and blocks of ice. This setting is a per-shader setting, independent of the double-sided setting on the object node.

We've made a lot of improvements in the renderer for refractive transparency, so you can apply the Water Shader or the Glass Shader to a variety of objects and get much better results than before.

The "transparency" parameter has been removed from the Reflective Shader. It wasn't working in previous versions. For refractive transparency, use either the Glass Shader or the Water Shader.

On surfaces that have inverted normals, diffuse lighting now renders as though the normals were not inverted. Flipped normals may still have consequences for other types of shading, such as reflection and refraction.

There may be other differences in some shaders as a side-effect of a change in the way normals are calculated by the renderer. Some of these differences may be accidental. If something renders differently from previous versions and you think it might be a bug, please let us know.

Reduced some sources of noise in atmospheres and clouds that are reflected or refracted by Water and Reflective Shader, due to undersampling at higher trace depths.

Animation Check Button no longer checks the value of "fully adaptive".

Added a "Render All To Disk" button on the render node. "Render All To Disk" is similar to "Render Sequence" except that it renders only the current frame. It renders an image and automatically saves it to disk according to the "output image filename" specified under the Sequence/Output tab. It also automatically saves any Render Elements to disk if "extra output images" is checked under the Sequence/Output tab, according to the settings there. Terragen does NOT warn you before overwriting any existing files, so be careful to check the output settings before using this feature.

Fixed a bug with 2D motion blur of clouds when no cloud element was enabled in the Render Layer. This was a bug because motion blur should not require a Render Layer or any elements to be enabled. This bug was introduced in Terragen 3.1.

Reduced memory requirements for 2D motion blur if "atmosphere visible" is off or if a render layer has "allow atmosphere visible" turned off.

Added some console/CLI output during the processing of 2D motion blur.

Sunlight's "sample jitter" parameter for soft shadows is now a checkbox. Previously it was a value between 0 and 1, but values other than 0 or 1 were rarely a good idea.

Fixed a bug with opacity lookups on imported objects without UVs or UVWs.

Fixed bug #622: Ray-traced holdout objects showed atmosphere when "atmo/cloud on background" was turned off.


CLOUDS

"Taper top and base" parameter on Cloud Layer V2. This enables or disables the built-in vertical profile that shapes the cloud. This is turned on by default. It can be useful to turn this off if you want to precisely control the cloud shapes using other methods.


HEIGHTFIELDS, SHADERS AND FUNCTIONS

New functions nodes: Max Scalar, Min Scalar, Soft Maximum Scalar, Soft Minimum Scalar.

The Geog image map shader has a new "Reproject on the fly" parameter in the Georeference section of the Location tab. If this is checked then the shader is able to dynamically reproject images so they line up much more accurately with other georeferenced data. Previously for the best results you would need to reproject or warp the original data to a suitable projection. With this parameter checked you can use the original data unchanged. Note that the georeferencing information from the file is used when this is checked, and changes to the georeferencing parameters won't apply.

The Geog image map shader has a new "Load method" parameter. This allows you to choose between loading the image via GDAL or using TG's internal image loading. You should prefer the GDAL method for geographic type images, but the TG method can be useful for other sorts of images, is more consistent with image loading in other nodes and supports some formats GDAL doesn't support, such as OpenEXR.

The Geog image map shader now has a "Flip" tab, with settings to flip images in the X and/or Y axis.

The Geog image map shader replaces NODATA values more efficiently.

Fixed some problems with loading certain colour formats in the Geog image map shader.

Fixed a georeferencing bug when loading a new file into an existing Geog image map shader (bug #567).

The Geog heightfield load node has a new "Set to Min Height" button. This sets the NODATA value to the minimum valid elevation in the heightfield.

The Geog image map shader and Geog heightfield load node are more efficient when updating file info/statistics.

There is a new Open Multiple Files dialog. This is currently used to load multiple DEMs or georeferenced images. It allows you to choose multiple files individually or scan a folder for images which match certain criteria. At the moment it can be used to create multiple Geog heightfield load nodes or multiple Geog image map shader nodes. You can access it for DEMs from the Add Terrain button in the Terrain node list. Choose "Heightfield (load multiple DEMs)" from the button's menu. For images choose the "Load Multiple Geog Image Map Shaders" from the Add Layer button in the Shaders node list.

Simple Shape Shader sets its position key parameters to "position in texture" when it is first created.

Fixed a bug whereby Alpine Fractal v2 wasn't properly setup after initial construction until a parameter is changed. Fixes bugs #595 and #614.

Fixed bug #543 in Alpine Fractal v2 that would change the number of octaves when loading some files. As a result, this shader now behaves a little differently from before. Changing "scale step" changes the smallest scale instead of num octaves.

Shaders and functions that use Voronoi noise are a slightly faster now.


POPULATIONS

If using a population cache file, the "Save Cache" button causes a repopulate instead of saving existing pre-loaded data.

Fixed a problem where you couldn't edit population instances if a population had "Show b-box in preview" turned off (bug #575).


GENERAL

Mac only: The Mac version disables App Nap during rendering on OS X 10.9 Mavericks. This may improve rendering performance, although it may be at the expense of battery life on laptops.

Mac only: The Mac version has been built in a slightly different way for this release. Please let us know about any problems you have, even minor ones.

Objects and light sources with import chan button now have import scale and import offset parameters. Some layout changes to affected nodes (including Planet). On some nodes the chan import is moved to a separate Import tab, while on others it remains with the Transform params.

Fixed a problem that could make the 3D Preview draw slowly if there were object nodes that failed to load their object files.

Fixed a bug that prevented 3D Previews from previewing Image Map Shaders that project through camera when no camera is attached.

Some changes to the size and position of the group that is created when using Edit -> Group.

Windows only: Some changes to the parenting of some windows.

Many undo descriptions are now more descriptive.

Some places in the GUI that were applying some formatting to node names to "humanize" them now use the raw node name.

The node parameter view layout has been adjusted for 2 component vector parameters, so they take up the available space making it easier to see longer values.

Added a "View Undo History" menu item under the Undo item in the Edit menu. This opens the Undo History window, just like the equivalent item in the View menu.

The Node Palette now has a search field, allowing you to search for nodes by name.


LIBRARY

The Library window search field has had some behind-the-scenes changes, please let us know if you have any problems with it.

The Library window no longer tries to create previews for JPEG 2000 images. Attempting to create previews for large orthoimages/satellite photos could cause sluggish behaviour in the Library window.

Worked around a problem where trying to add particular images from the Xfrog collections would cause the Library to crash.

Mac only: Gesture scrolling now works for browsing mode in the Library window main list.


Build 3.1.02.0 (Release)


3D PREVIEWS

The subdivision and displacement engine in 3D Previews and Shader/Heightfield Previews is now multi-threaded. It uses up to as many threads as there are cores detected on your system or specified in the user override in Preferences. It can also be limited by passing a command line option, -previewthreads numberOfThreads. If numberOfThreads is 0, the subdivision and displacement engine works in the main app thread as before.

The 3D Preview renders faster when true lighting is disabled or there are no Enviro Lights enabled in the scene.

The GI prepass detail level in the 3D Preview has been increased slightly.

3D Preview now respects micropolygon opacity in the same way the renderer does, as long as shaders are enabled in the preview. This was broken when multithreaded preview shading was introduced in Terragen 3.0. Fixes Bug #499.

POPULATIONS

Anchor populations to objects: Populator v4's "Terrain" tab has been renamed to "Anchor". On this tab you can choose between "Sit on terrain", "Sit on object" and "Free floating". If you choose "Sit on object", instances are placed only on the surface of the object you specify. This can be any object in the project, even ones that are disabled for rendering. Positions are calculated by casting rays "downwards" from the populations area until they hit the surface of the object. By rotating the population area you can change the "downwards" direction in order to cast instances onto different sides of the object. After initial instance positions are calculated using the ray casting method, displacement shaders on the object will displace them into final instance positions. In future we would like to provide ways to populate instances on multiple objects but we have some technical problems to solve first.

Populator v4's "Lean to terrain normal" is now called "Lean to terrain/object normal" because it works just as well when anchoring to objects.

Populator v4 has a small change to the effect of "Lean to terrain/object normal" when the instances are far away from the top of the planet. In most cases the differences will be small, but the change was needed to support the new features.

Populators now put up a warning and don't populate if you try and populate when one of the object spacing parameters is 0.

Loading population instance caches is now faster (around 1/3 quicker) and uses less memory.

Fixed a crash when aborting population, which was particularly obvious if population was triggered by rendering starting.

Made some improvements to selection behaviour when editing population instances.

The Deselect command is handled when editing population instances.

OBJECTS

New object: Cube. This is a "displaceable object", like Disc, Lake, Plane, Planet and Sphere. Cubes can be positioned, rotated and scaled. Corners are rounded using a "Round radius" parameter. The roundness may be important when applying displacements.

New object: Octahedron. This is a "displaceable object", like Cube, Disc, Lake, Plane, Planet and Sphere. Octahedrons can be positioned, rotated and scaled. Corners and edges are rounded using a "Roundness" parameter. The roundness may be important when applying displacements.

Sphere can now be rotated (after scaling). Rotation and scaling can now be done in the 3D Preview.

Sphere has radio buttons to choose between "Proper surface normals" and "Scaling deforms normals". These options are active when the scaling is non-uniform (i.e. the sphere is stretched), and they affect how the surface normals are generated on the stretched sphere.

The Disc node has had a bit of a revamp. The parameter view has been rearranged and harmonised with similar objects. The Disc can be double sided.

Disc draws a wireframe preview and has larger handles.

Lake draws a wireframe preview. The wireframe is correctly distorted by planet curvature.

Wireframes and bounding boxes of displaceable objects (Cube, Disc, Lake, Octahedron, Plane, Planet and Sphere) are drawn with a turquoise/aqua colour. This is to differentiate them from non-displaceable objects.

The drop point of an object now shows when you mouse over the "Drop to terrain" button in transform panels.

SHADERS AND FUNCTIONS

There is a new "Geog image map shader" node which can load georeferenced images. It can be used as a colour shader or a displacement shader.

The Image map shader has two new parameters in the Effects tab. "Use alpha/transparency for direct blending" will blend the image with underlying surfaces based on its alpha channel or any transparency generated through keying, without having to mess about with masking shaders. "Invert alpha/transparency" inverts the image alpha or generated transparency. 

The Image map shader now defaults to Plan Y projection. It sets the size of the image so the longest side of the image is 500m and the image has the correct aspect ratio.

The Heightfield Shader allows you to choose the displacement direction. Options are "Vertical (normal in geometry)", "Normal" and "Y axis". Y axis is the default for backward compatibility, but any newly created nodes will default to "Vertical (normal in geometry)".

The Heightfield Shader's "Flatten surface first" now has 3 modes to choose from: "to Undisplaced Surface", "to Computed Terrain (pos. in texture)", and "to Y = 0". When loading existing projects or clips this will default to Y = 0 for backward compatibility, but new nodes default to Undisplaced Surface because this is usually better for heightfields which may appear anywhere on the planet.

If a heightfield is georeferenced, the Heightfield Shader no longer limits it to the +Y hemisphere of the planet.

Fixed a bug whereby some default parameters weren't being set for heightfields loaded from the Library.

Fixed a bug whereby some default parameters weren't being set for heightfields added with the "Add Terrain" button.

4D noise can be used without crashing.

Power Fractal Shader V3 and Cloud Fractal Shader V3 allow "smallest scale" to have very small values again, safely.

Added "altitude key" parameter to Surface Layer. Behaviour should be unchanged with the default value. Improved GUI layout of "use Y" and "slope key" parameters.

Improved GUI layout of "use Y" and "altitude/slope key" parameters on Distribution Shader V4.

New function node: Build HSV Colour. This operates in a similar way to Build Colour, except that the secondary, third and fourth inputs are interpreted as hue, saturation and value, instead of red, green and blue. The output is an RGB colour.

Previews of warp shaders no longer render black when their inputs don't generate any colour. The preview should generate some default shading for displacement-only shaders, and this now works with warp shaders that follow displacement-only shaders.

Shader previews draw shader bounding boxes, wireframes etc., as they do with heightfields.

Newly-created fractal shaders now properly disable the "ridge smoothing" and "gully smoothing" parameters for the default Perlin noise flavour. Fixes Bug #536.

Cloud Layers no longer have a "ray fuzziness" parameter.

PAINTED SHADER

The Painted Shader has a new back end. This should greatly improve stability with large amounts of painting. It removes problems with doing things like painting from the terrain onto the sky. It also fixes the problem where you would do a lot of painting, save the project and then find TG would crash when you tried to open the project.

When painting with the Painted Shader, the semi-transparent grey overlay in the 3D Preview has been replaced with a dark tint that shows more contrast in the scene being painted over.

The Painted Shader brush outline is drawn in orange, which stands out better against the painted strokes (unless you're painting in orange!)

While editing a Painted Shader, the Paint Session Menu on the 3D Preview has a new item to open the parameter view for the node being edited.

RENDERING

Mac and Linux only: Fixed some differences between Mac/Linux and Windows renders.

Atmosphere and cloud rendering is now significantly faster in many cases.

Fixed some rendering problems with spherical camera, particularly near the top and bottom of the image. Spherical renders now render faster too.

In some situations where an object's shaders were changed, the object was rendered with the old displacement shaders. This has now been fixed.

The prepass no longer renders if there are no Enviro Lights enabled in the scene, speeding up renders in this case.

GENERAL

Linux only: The Linux version is now built with a different compiler version (gcc 4.4) which fixes various weird problems that could crop up. An example of this was the incorrect rendering of TGO objects, which was fixed with a workaround in the previous version.

Mac only: The Mac version is built with a new compiler. In some cases there are small improvements to rendering speed.

Mac only: Made some changes which should improve some erratic UI behaviour especially noticeable on Mavericks.

The "Add Object" menu on the Objects layout now looks like this:
    From Library...
    Object >
    Displaceable Object >
    Population >

Population menus throughout the application show only populatable objects.

Fixed a bug (introduced in 3.0.10.0) with item filtering in the Library window when it's been opened for a certain item type (i.e. Objects, Projects).

Fixed a problem with the Library where rectangular item icons/previews would be drawn as square, making them look stretched.

The Undo description for node creation contains the name of the node (unless more than one node is being created). For example, Undo might display "Undo Create Heightfield Shader 01".

Added a Deselect menu item to the Edit menu. This works in the 3D Preview, network view, animation panel curve editor and dope sheet.

Stopped values from being cut off in the position readouts on the 3D Preview, and formatted them in a more readable way when the numbers are very large. The improved formatting also applies to the 3D Preview Location window and the measuring tool.

When a camera is highlighted or selected in previews, the camera body wireframe is highlighted like the frustum is.

The Camera node has a new "Show camera body in preview" parameter that lets you turn off drawing of the camera body in the 3D Preview. This can reduce visual clutter when you have a lot of cameras in a scene.

The "Customise Bindings" button in the Input Settings prefs panel is now enabled all the time. Clicking the "Customise Bindings" button will open the Custom Bindings window and set the "Input presets" popup list to "Custom".

Fixed a problem with split panes that could cause the vertical splitter bars to resize incorrectly on the Mac, for example in the top left of the main window between the node list and mini preview. Please let us know if you have any problems with split panes.


Build 3.0.10.0 (Release, Windows/Mac only)


RENDERING

Fixed two problems in renders that combine GI Surface Details and DoF with Noise Reduction. Edges of buckets (tiles) sometimes had visible lines, and subpixel details in GISD weren't being calculated.

Fixed a problem with DoF with Noise Reduction that would occasionally be visible at the edges of buckets (tiles).

LIBRARY

Library drawing performance in browser mode is greatly improved, especially on Windows. To take advantage of this for existing Library items you will need to upgrade the previews (see below).

Library previews are now saved using JPEG 2000. The Library can also upgrade existing item previews to optimise them for drawing speed and disk space usage. If TG detects that this needs to happen it will prompt you to do so when the Library window is opened. Technically the upgrade process converts any TIFF previews to JPEG 2000 to save disk space and then generates smaller versions of previews to optimise initial preview loading. This speeds up Library window opening and initial scrolling in browser mode.

Additional Library window search capabilities. You can now search for multiple tags. You can also choose to match any tag or all tags.

Fixed a problem where the Library window might not save its display configuration in certain situations.

The main list in the Library window now displays a tooltip showing the file path for an item when you mouse over the Name column while holding down the alt/option key.

The Library window now has several options for filtering by the date an item was added. See underneath the Recently Added item in the Contents list.

Fixed a problem when adding preview images to project files and clip files in certain situations, mainly if they had any comments/descriptions etc. containing quotes ("). At worst this could lead to the file not opening, although the file content was still intact.

Fixed a crashing bug when adding a preview to a project from the info panel in the Library window, when the project was the one currently loaded.

Windows only: Fixed a problem where files could be left open until TG exited after selecting them in the Library window.  

Windows only: Improved the redraw behaviour of the Library window in browser mode when the Library window is being resized.

GENERAL

The way the main window size is set at startup has changed.

Fixed an occasional crash while populating with Populator V4.

Fixed a drop-to-terrain bug where the dropped item's position/translation parameter might not update in the UI if the items node view was open.

A number of open/save dialogs opened from nodes now have file format popups.

Windows only: Made an improvement to window behaviour when the OS colour picker (opened from the TG colour picker) is closed. It shouldn't cause random windows to come to the front anymore.

Fixed a problem with the Geog heightfield load node where DEMs didn't have the correct size calculated in the Free and Creative editions.

TG now loads colours from indexed/paletted images. It also loads images with bit depths of 1 (monochrome) and 4 (indexed).

Add a hotkey to toggle between paint and eraser strokes when painting a Painted shader. The default key is V.

Added missing text for the "Toggle Depth-of-field preview" item in Mouse and Key Settings dialog and Customise Input Bindings window.

Tweaked the icon position for the Add Preview to Project button in the Render window.

Input presets in the Input Settings prefs panel have been renamed from "One button" to "One mouse button" etc.

Mac only: Made some changes to the way colour is handled in UI elements. This doesn't affect rendering. However one noticeable change is that rendered images are displayed in the Render view with colours that match more closely to the colours of saved renders. To emphasise this again, rendering is not affected.


Build 3.0.07.0 (Release)


Significant improvements to stability.

Soft shadows now render faster in some situations (undoing a change that was made between v2.5 and the first v3.0 builds).

Changed the way object handles/manipulators are drawn. They should no longer be obscured by other objects. Please let us know if you noticed anything unusual with the 3D Preview drawing.

Fixed a problem with the Populator 4 where modified instances might not initially be in their correct locations.

Changed the way populations (v3 and v4) draw their instance bounding boxes. Previously instance bounding boxes would always overdraw other objects, now they're better integrated.

Further improvements to upgrading Populators to v4.

Populator v3 is now better at drawing full geometry objects closer to the camera in wireframe/smooth shaded/textured modes. Populator v4 was already doing this.

Picking for translation handles has changed so it's no longer possibly to accidentally pick two axes for dragging.

The main window has a larger minimum size (1250 pixels wide).

There is a new Depth-of-field preview for the 3D Preview. When it's turned on a transparent plane is drawn across the preview which corresponds to the Camera Focus distance. Anything coloured by the plane is further away than the focus distance. You turn on the DOF preview using the new button (iris icon) next to the Measure button in the top toolbar of the 3D Preview. There is also a hotkey set to L by default. If the 3D Preview is set to the render camera or other user camera the DOF preview updates as you change the Focus distance. You may find the DOF preview disappears if it gets closer than about 1m. Objects that close will be clipped anyway. To see them you will need to decrease the near clipping plane distance in the 3D Preview ( [ key ).

Added the 3D Preview Depth-of-field preview colour to the Interface Colours prefs panel.

Fixed a problem with the 3D Preview where object manipulators wouldn't draw if the thirds lines or crop region was displayed.

There is a button in the top toolbar of the main window to open the Library window.

Fixed a Library issue which could lead to items being added multiple times in certain situations.

Removed the "Lock size to image aspect ratio" parameter from the Image map shader for now.

Made some improvements to stepper behaviour for double parameters (i.e. Cloud Altitude).

The Free version splash screen now has a button to add a key file, intended to make it easier to add a key file to TG3.

There is a new "Add License Key File" menu item in the Help menu, intended to make it easier to add a key file to TG3.

The About Box now displays the Edition of TG3 being used.

Changed some of the text in the Library prefs panel to clarify what the preferences do.

Fixed a problem with the Node Palette where the top panel wasn't switching between the popup list and full list when the splitter was moved.

The Clump diameter slider for the Grass clump is now continuous from the default value of 10 down to 0.


Build 3.0.05.0 (Pre-Release)


Fixed some crashes relating to:
- Updating of populations after changes to attached objects, especially noticeable with Grass clump and Rock objects (with Populator v4).
- Georeferenced heightfields in the case where the planet's "lat-long at apex" parameter has the default value (0,0).
- Unknown errors occuring while shading the 3D Preview are now caught and reported as errors rather than crashing.

Linux only: Fixed a crash parsing frame number command line arguments on some Linux distros. 

Fixed some problems with upgrading Populators to v4.

Changed the way Populator v4 calculates progress, it will now run to 100% or thereabouts when calculating instances.


Build 3.0.04.0 (Pre-Release)


In many shaders, "Blend by shader" and "Blend by heightfield" are now called "Mask by shader" and "Mask by heightfield". "Blending shader" and "blending heightfield" are now called "Mask shader" and "Mask heightfield".

Changed default project: added a Fractal warp shader and made the Simple shape shader use "position in terrain/texture".

The Populator v4 can tint the diffuse colour and luminosity of objects on a per-instance basis. Colour shaders or functions can control the tint, as well as overall multipliers. Only Default Shaders are affected.

Fixed a bug where population instance caches over a certain size wouldn't be written correctly.

Optimised memory use for population and writing population instance caches.

Writing population instance caches should be considerably faster. For one large test population it was 10x faster.

The Populator v4 now shows the total number of instances in the population on the Editing tab. Not super obvious but the only place to fit it right now.

Removed the "Use instance cache" parameter from the Populator v4 Cache Settings parameter view. Whether to read a cache file is now controlled solely by the "Use instance cache" parameter in the Populator v4 param view.

You can now upgrade a Populator v3 to a Populator v4. You do this using the Objects node list. Select a Populator v3 and then go to the Action button (button with gear icon at the bottom of the node list) and choose "Upgrade selected population to v4" from the menu. You can only upgrade one population at a time at the moment. A new Populator v4 node will be created with all the settings of the original node. The original node has "(Pop v3)" added to its name and is disabled. Note that before you delete the original node you'll need to copy any nodes inside it, like the object maker node, into the new node.

Fixed a bug whereby Populator v3 and Populator v4 would repopulate after pasting any other nodes into the project. Behaviour may be improved in other situations too.

Fixed a bug whereby objects would reload after pasting any other nodes in the project.

Fixed a problem with the Library which prevented items that had apostrophes/single quotes in their information from being added.

The default/custom startup project no longer shows up in the Library when you start a new project.

There is a new "Date added" list sort order method for the Library window.

Improved input detection when creating clip files.

Made improvements to centreing on objects/shaders in the 3D Preview with orthographic views.

The Objects node list now has a Preview button in the top right. This will show or hide the small Objects node list preview. This is remembered across TG sessions, so if you don't want to see the object preview you hide it and it'll stay hidden.

The Image map shader has a new "Lock size to image aspect ratio" parameter, which will make sure any changes to the Size parameter keep the same proportions as the loaded image. The size of the loaded image in pixels is also displayed underneath.

The Geog heightfield load node has a new "Update" button for updating a DEM when the NODATA replacement value changes, instead of updating happening while the value was changed. The "Update" button is only enabled when "Replace NODATA values" is checked.

The Geog heightfield load node uses the spheroid/planet size from the coordinate system information (if available) to work out the size of the heightfield.

Fixed a problem with unit conversions when importing a camera from FBX using the Camera node Import tab.

Fixed a problem where pasted/duplicated nodes wouldn't show up in the node lists.

Stopped a lot of debug and other information being printed to the console.

Power fractal shader v3's default smallest scale is 0.01 (was 0.1).

GI relative detail, which is a legacy parameter, is now hidden in release builds.

Lake defaults to water level of 1, so that it is visible when added the default scene.

The 3D Preview's maximum detail is 80 again.


Build 3.0.02.0 (Pre-Release)


IMPORTANT

The Mac version is now Intel only. PPC is no longer supported (sniff!). The oldest version of OS X now supported is 10.6. TG will not run on earlier versions of OS X.

The folders used by Terragen for storing the license key file, preferences data, favourite nodes for the node palette, colour picker settings and automatically saved renders have changed. In most cases, wherever a folder named 'Terragen 2' or 'Terragen-2' was used before, now the folder named 'Terragen 3' or 'Terragen-3' is used.

License key file and library database (work in progress) are stored here on Windows (depending on your Windows setup):
C:\Users\<user>\AppData\Roaming\Planetside Software\Terragen 3

and here on OS X:

~/Library/Application Support/Planetside Software/Terragen 3

Preferences data file preferences.xml is stored here on Windows (depending on your Windows setup):
C:\Users\<user>\AppData\Roaming\uk.co.planetside\Terragen-3

and here on OS X:

~/Library/Preferences/uk.co.planetside.Terragen-3.plist 

Renders are no longer automatically saved to the temporary items folder. There is a new preference called "Automatically save all renders" in the Rendering prefs panel to control this behaviour. This is off by default. If you did previously take advantage of the fact that renders were automatically saved you will want to turn this on. Renders are no longer saved in the temporary items folder. They will now be saved in a "Terragen 3" folder in your Documents folder. You can change this save location by changing the "Automatic render output" path in the Customise Default Paths section of the File Saving prefs panel.

If you have an existing project that uses extra output images to output the alpha image, the alpha will be now be rendered to a subfolder called 'tgAlpha' unless you turn off the "Create subfolders" option on the render node.


MAJOR CHANGES

In the Free Non-commercial Edition, max detail is 0.6 and max AA is 4.

The render size limit in the Free Non-commercial Edition is now 1280 x 900.

Render Layers and Render Elements.

There is a render node for Linux.

A Library window has been added.

There is a new Populator v4 node. This node adds population instance editing and population instance caching. Another minor but important change is that this node restricts instances to the population bounds.

Please note that the Populator v4 is now used for all newly created populations. The Populator v3 node is still available but hidden. Any old projects will still load fine and use the Populator v3 node. We will provide a way to upgrade Populator v3 nodes to v4.

The Populator v4 uses multiple threads when populating. In tests average speedup was 6.5x with one complex scene populating 10x faster (on a 16 core machine).

Shaders and atmosphere rendering are multi-threaded in 3D Previews and shader previews. These previews now render much faster in many cases. This build uses significantly more RAM for the 3D Preview, and this varies with the number of micropolygons in the view. We will reduce this RAM overhead in the next build. The maximum detail in the 3D Preview has also been increased to 160 (previously it was 80).

GI detail is now specified as an absolute detail level called "GI cache detail". This produces results which are independent of the render detail. Render resolution still affects the results, however. The old "GI relative detail" maps to an equivalent value of the new "GI cache detail" in a particular way. Examples: GI relative detail 1 with render detail 0.5 is equivalent to GI cache detail 2. GI relative detail 2 with render detail 0.5 is equivalent to GI cache detail 4. Both "GI cache detail" and "GI sample detail" are non-integer parameters now (you can enter fractional values). If a project was saved in Terragen 2.4 or later and has a Render GI Settings node then the old "GI relative detail" will be automatically converted to use the new GI cache detail setting. Other projects will use the new default GI cache detail of 2.

"GI surface details" now uses a new algorithm to produce higher quality results in a much shorter time. Additional controls are available.

The default scene has changed.

Spherical projection option in Camera. This allows you to produce a "lat/long" or "spherical" render with 360 degrees field of view horizontally, 180 degrees vertically. The rotation of the camera matters. Usually you would set the camera's rotation parameters to (0,0,0) when using spherical projection. Of course, the camera's position also determines the point at which the scene is viewed from.

There is a new "Create Clip File" dialog. It allows you to do things like define input and output connections for the clip and add a description and connection tips. When you insert a clip with an input and/or output connection defined TG attempts to connect the clip into the node network using them.

A new method of grouping nodes has been added to the network view. You can now drag and drop nodes on a group to add the nodes to that group. Conversely you can drag nodes out of a group to ungroup them. Groups show drop target feedback when you drag nodes over them to show that the dragged nodes will be made part of that group if the nodes are dropped on it.

When a node is over a group it's not grouped by it's drawn with a white border. The intention is to clarify when nodes are part of groups.


RENDERING

There is a motion blur checkbox on the render node's Quality tab, which can turn motion blur on or off without affecting the output of motion vectors (only with Animation module).

2D motion blur option (only with Animation module). Choose between 2D motion blur and 3D motion blur on the render node's Quality tab (3D motion blur only available in Professional with Animation).

Depth of field rendering can be enabled on the render node's Quality tab. You can also choose between different DoF rendering modes.

"Ray detail region" has 2 new modes to choose from called "360 degree detail (optimal)" and "360 degree detail (highest)". With "360 degree detail (highest)", the subdivision detail of ray traced displacements is uniform in all directions around the camera position, even behind the camera. "360 degree detail (optimal)" is similar except that detail is reduced by a factor of 3 behind the camera, with a smooth transition from front to back. In both of these modes "ray detail region padding" has no effect. They do not work with orthographic cameras. With perspective cameras they should help to avoid popping shadows and other ray traced displacement artifacts originating from outside the camera's field of view. However, beware that this will increase render times greatly so if there are any ray traced reflections appearing on objects with high curvature or displacement.

Fixed a long-standing bug with Planes and other displaceable primitives (except Sphere and Planet) that would produce incorrect displacement in a recursive grid-like pattern when those displacements are followed by a Compute Terrain or Tex Coords from XYZ. This was often noticeable in the shader preview but also affected full renders of these primitives.

Fixed a fairly big performance problem with empty Heightfield Generate nodes, especially on the Mac.

A big speed improvement to multithreaded rendering in scenes that use voronoi functions, voronoi fractals or fake stones shaders.

Windows only: Reduced thread priority for secondary render threads to improve system performance while rendering.

More information is output to the console about which frames are to be rendered and being rendered.

"Sorting bias" parameter on objects.

Optimising clouds and atmosphere in the case that they have their enviro light contribution set to 0 or their colour is 0.

Reduced occurrences of false positive shadows where the casting surface is not fully facing the ray direction (e.g. near the terminator of a sphere). This only affects subdivisible surfaces, and only when ray detail multiplier is not 1.

Image file processor (only in Professional Edition and Professional with Animation). This allows you to load an EXR (or a sequence of EXRs if you have the Animation module), apply TG's tone mapping and motion 2D motion blur effects, and output a new image or image sequence.

Alpha channel is now AA bloomed. Extra elements are not AA bloomed.

Weighting of anti-aliasing bloom is always based on luminance of the beauty element, not the element being bloomed, so that bloom weights are the same in all elements.

Fixed a bucket padding error for anti-aliasing bloom.

Renamed atmosphere to "atmo/cloud" in some parts of the render GUI. E.g. "Atmosphere visible" is now labeled "Atmo/cloud visible", and "Ray trace atmosphere" is now labeled "Defer atmo/cloud".

When saving images as a TIFF you can now choose to save the image with 8 or 16 bits per channel, with or without compression.

A new preference, "Render save format", has been added to the File Saving prefs panel. This lets you choose the default format used for saving rendered images. Automatic render output also respects this preference.

Added an "Explore/Reveal Automatic Render Output Files" item to the File menu which shows the save location for automatic render output files.

Dither is applied to 8-bit images as they are converted from 32-bit images. This should prevent colour/brightness banding in uncompressed 8-bit images.

Soft shadows from atmosphere no longer have reduced samples or reduced importance of each sample. This improves the quality of images that are affected by this, but may increase render times.

Detail slider maximum is now 0.8. You can still enter higher values by hand (although detail is limited to 0.6 in the Free Non-commercial Edition).

Fixed a problem with AA bloom. It may look slightly different now.

The Render view now has a "Best fit" input binding. It uses the F key by default.

Corrected ray intersection bug with perfectly flat, level planes.

The Render window now has a channels button to allow you to choose the image RGBA channel to display (only in Professional Edition and Professional with Animation).

Various objects have a visibility mode allowing {Invisible, Holdout, Visible}. Holdout mode is only available in Professional Edition and Professional with Animation.

Spotlights.


TERRAIN, SHADERS AND FUNCTIONS

There is a new node for loading DEMs called Geog heightfield load. This can be created from the Add Terrain button menu in the Terrain project view. Choose "Heightfield (load DEM)" from the menu. This node uses GDAL to load and potentially georeference many DEM file formats.

New shader: Transform Input Shader. This transforms texture coordinates used by the shaders attached to "input node". Unlike Transform Merge Shader it has no separate "shader" connection; it affects "input node" instead.

Renamed shader: Transform Shader -> Transform Merge Shader. This transforms texture coordinates used by the shaders attached to the "shader" input and applies those shaders after the "input node" shaders. The old shader can still be loaded from old projects and clips.

New shader: Warp Input Shader. This uses a displacement shader to warp (distort) the texture coordinates used by the shaders attached to "input node". Unlike Warp Merge Shader it has no separate "shader" connection; it affects "input node" instead.

Renamed shader: Warp Shader -> Warp Merge Shader. This uses a displacement shader to warp (distort) the texture coordinates used by the shaders attached to the "shade" input and applies those shaders after the "input node" shaders. The old shader can still be loaded from old projects and clips.

New shader: Vortex Warp Shader (work in progress). This uses a built-in vortex function to warp (distort) the texture coordinates used by the shaders attached to "input node".

New vector function: Vortex Vector (work in progress).

Checkboxes in the Transform Input Shader and Transform Merge Shader now enable and disable the controls for the associated parameters.

New "ridge smoothing" and "gully smoothing" parameters on the Power Fractal Shader V3 and Cloud Fractal Shader V3. These only apply to some noise flavours and their controls are disabled whenever they do not apply to the chosen noise flavour. Small values (e.g. 0.1) round off the sharp lines in the Ridges, Billows, Perlin Mix 1 and Perlin Mix 2 noise flavours. Larger values have a much stronger effect on the overall shape of the noise and can greatly change the look of the fractal. For newly created nodes these parameters now default to 0.1.

Power Fractal Shader V3 and Cloud Fractal Shader V3 can no longer produce noise scales below 0.01 to reduce the chance of errors.

Power Fractal Shader V3 has an Animation tab with an option to use 4D noise and parameters to animate the fourth dimension.

New function: Perlin 4D Scalar

Fake Stones Shader has an option "apply colour" to enable or disable the application of colour. Any attached surface shader is applied regardless of this setting.

Painted Shader now allows non-diffuse components of its input (such as reflections and luminosity) to pass through where there is no paint. Previously the Painted Shader would replace all of the surface with a diffuse surface.

Renamed the "Auto generate" option on the Heightfield Generate node to "Generate at load time", and made it only auto-generate once at load time or the first time the heightfield is used in a shader network (e.g. after pasting and connecting). The box is automatically checked when you press the Generate button.

All shaders automatically check/uncheck their "blend_by_shader" parameter (if they have one) when a blend shader is connected/disconnected by the user.

New function: Displacement Shader To Scalar. This is similar to Displacement Shader To Vector except it returns the dot product of the displacement and the surface normal. This is usually more useful than the vector version when manipulating displacement with functions or using a displacement as a mask, for example.

Added a "Transform/Warp Shader" submenu to all shader menus. "Other Surface Shader" submenu on "Add Layer" button renamed to "Surface Shader" for consistency with equivalent submenus elsewhere in the program.

New shader: Fractal Warp Shader (in Transform menu). This uses a similar algorithm to "Fractal Detail" on the Heightfield Shader, except that it warps the whole input shader network and has blend shader options.

The Image Map Shader has RGB multipier and RGB offset parameters. They only affect colour, not the shader's built-in displacement. These parameters are useful because they affect only the image, not the areas outside the projection. The RGB offset is particularly useful when working with displacement vector images that are centred on grey instead of black. In that case an RGB offset of (-0.5, -0.5, -0.5) would be necessary.

The Simple Shape Shader has two new options in its Displacement tab - "Displace relative to surface" and "Displace relative to shader position". The "Displace relative to surface" option uses the previous behaviour where the displacement happens relative to the underlying surface. The "Displace relative to shader position" option makes the displacement happen relative to the shader Y position.

The Simple shape shader has a new parameter called "Show shape edges in preview" which controls whether or not the shape edges (orange dotted line) are drawn in the preview.

The Simple Shape Shader now allows you to apply the main and edge colours independently.

Fixed a bug with the "re-scale vertical" parameter of Heightfield Resize.

16 bit RGB/RGBA image loading (including images with compression) is now better supported.

16 bit greyscale images are now loaded.


3D PREVIEW, OBJECTS AND POPULATIONS

Mesh displacement options on object readers (only in Professional Edition and Professional with Animation).

Mesh subdivision, mesh displacement and shattering options on the Rock object.

Populations allow translation handles to move the population centre in Y. This is useful to move the populator bounding box to where the instances appear on the terrain, and is also useful away from the origin.

Sphere has a scale parameter to allow non-uniform scaling.

3D Preview navigation (panel/keys etc.) no longer normalises rotations. This is to make it easier to create animations.

The 3D Preview can now display objects with textures, although to see them textured you will need to change the master preview mode on the 3D Preview. At the moment textures are only shown in certain situations. Objects need to be set up in a particular way for textures to be shown. Materials need to be connected to the object via a Parts shader or Multi shader and then each part of the object needs to be connected directly to a Default shader with no other nodes in between. Textures are created from the diffuse colour and/or diffuse colour image and the opacity image of the Default shader. In the future textures should be generated in a less specific manner.

Newly created objects now use the textured preview mode by default.

Smooth shaded mode is available for objects in the 3D Preview.

Drawing of populations in the 3D preview uses billboards for objects in the middle distance.

Picking behaviour has changed in the 3D Preview. The selected item now has priority for picking. This improves the situation where you could be manipulating an item, let's say dragging it, but then find some other item is selected and moves when you try to drag the selected item.

Objects and shaders now have rotation and scale manipulators (if appropriate) in the 3D Preview, in addition to the translate manipulator. We're very keen to hear your feedback on them. Here's how they work:

- Selecting the transform mode: Select an object and click one of the new buttons drawn under the transform handle (positioning needs work). You can also use the T key when an object is selected to move between available transform modes.
- Rotate: Mousing over an axis circle will highlight it. Click and drag to rotate.
- Scale: Click and drag on one of the spheres at the end of an axis line to scale along that axis. Click and drag on the centre sphere (magenta) to scale uniformly in all directions.

You can now drop an object and some shaders (those with translate handles in the 3D Preview) onto the terrain. There are two ways to do this. You can select the object and click the "Drop to terrain" button which is drawn with the new transform mode buttons. You can also press the D key when the object is selected. This will drop (or raise) the object along the Y axis at its current position so the origin of the object/shader is located on the terrain. This might not work as expected with extreme displacements.

Objects can now show a drop point in the 3D Preview. The drop point is drawn on the terrain where the object would be positioned if it was dropped to the terrain. The drop point only shows when the object is selected. You can turn the drop point on or off using alt/option-D.

For objects that are in "Member of a Population" mode, the preview display options controls (hidden/bounding box/wireframe etc.) are disabled because they are not effective.

The select camera button for 3D Previews has new icons for the different preset views.

Population drawing performance in the 3D Preview is improved. Smooth shaded mode in particular should be smoother and more responsive to object selection.

Fixed a crash when drawing populations when OpenGL support is not very good (Microsoft OpenGL driver for example).

Some GUI changes for object nodes.

An object's visibility parameters no longer cause the object to reload.

Fixed bug that would prevent populations from knowing they need to repopulate.

Windows only: Made an improvement when saving objects so that the file type popup in the Save dialog matches the type of the object (.obj for example) if the default filename has an extension. This improves a situation where the file type popup could be set to .tgo by default but the file always saved as .obj.

Terragen is now more tolerant with paths to texture files in MTL files (loaded along with OBJ files).

Objects now have individual previews in the way that terrains and shaders do. When you click an object in the Objects project view list (top left of main window) a preview opens next to the list. You can open the preview in a new window.

Objects and shaders can now be deleted in the 3D Preview.

You can now specify the colour that populations and some objects are drawn with in the 3D Preview with their new Preview Colour parameter. New populations have different preset colours assigned.

Populating now updates the 3D Preview straight away (bug 366).

"Centre on object or shader" in the 3D Preview now both centres on the specified item and fits the view to it.

Added "under terrain" indicator which appears if the camera is under the terrain. This is a little red mountain icon displayed in the top left of the 3D Preview, or under the compass if used.

"Enable or disable Shaders in the 3D Preview" button now works. When off, all "nearby" surfaces are rendered with an 18% grey diffuse surface. If both the Shaders button and the True Lighting button are turned off, then "background" surfaces (greater than 100,000 km from camera) are rendered with a blue-grey gradient. Displacements are still calculated when the Shaders button is turned off. The Terrain and Cameras layouts default to turning Shaders button off.

Fixed a problem where hidden nodes might have been able to be selected in the 3D Preview.

Only nodes that have preview enabled are available for selection from various menus such as Select, Centre On and Snap To menus.

The 3D Preview has a new hot key to fit the view to the selected object. By default this is the S key (fit to "S"ubject). The fitting behaviour may still need improvement.

Animation playback speed in the 3D Preview is greatly improved.

There is a new option in the 3D Preview display mode menu called "Show|Hide all object/shader preview bounding boxes". This toggles the display of bounding boxes for objects and shaders. You might want to hide these to make it easier to see other objects etc. in the 3D Preview. At the moment manipulator handles can still be large when drawn and obscure other things but we're looking to improve that. Please note that in the case of populations the bounding boxes effected by this don't include the bounding boxes for population instances but rather the bounding box for the entire population.

You can now turn all object preview bounding boxes on or off using the Action menu button at the bottom of the Objects node list. This basically toggles the "Show b-box in preview" parameter on or off. Not all objects have this parameter. This is not really the same thing as the new object display mode option described above. That is a lightweight operation and is more suitable for toggling bounding boxes on and off quickly. It also effects more than just objects. The Action menu item changes actual node parameters and is better suited to more permanent changes.


GENERAL AND USER INTERFACE

Animation data is now saved using 10 significant figures again, fixing a bug which meant a lower precision was used.

Duplicate nodes in the node palette list now show their parent class to distinguish between them.  Currently it doesn't matter which one of the duplicate nodes you choose, the same node with the same default settings will be created.

Windows only: Tweaked how tooltips for objects/shaders in the 3D Preview are displayed.

"Alpine Fractal (slow)" menu item renamed to "Alpine Fractal".

FBX import/export partially supports spotlights. This is a work in progress.

Various default values have changed in Planet Atmospheres (both the node defaults and in the default project) and Cloud Layers presets on the "Add Cloud Layer" menu. The sunlight node in the default project is also slightly stronger and has a slight blue cast to produce a better white balance in daylight.

There is a new input binding to zoom the render view or image previews to 100%. By default it's the "1" key.

Fixed a bug (472) where the main window timeline didn't update correctly when you started a new project.

More parameter file buttons support drag and drop.

The Library and Content preference panels has been split into two new panels. The new "Library" panel has preferences specifically relating to new Library capabilities. The new "Asset Search Folders" panel has the user content preferences from the old panel.

The Quick Node Palette (network view) can now has a hot key to show favourites. The default hot key is shift-N.

New input bindings: "Fit view" basic input (customise only), "Quick Node Creation (Favourites)" (network view), "Fit to subject" (3D Preview).

Mac only: Improved key handling to prevent annoying beeps when interacting with some views. You may still hear beeps if you use a key that's not handled by a view. If you notice a beep for a key that is handled (i.e. something changes in the view as a result) please let us know.

Fixed a bug where deleting a camera node that was the current camera in the 3D Preview could cause a crash.

Parameters can now be read only. This particularly applies to text fields. An example of this is the "XY size (metres)" parameter in the Statistics part of the Heightfield load node. You can select and copy text in these fields but not edit them.

Windows only: Made some changes to better support Windows 8.

New image preview. This can be used to preview images as they appear on disk, i.e. without shader effects. The preview can be opened using the file buttons next to parameters which take image files, such as the Image filename parameter of the Image map shader. These file buttons now have little arrows on them and you can click them to pop up a menu where you can choose a file or preview the file. The image preview uses many of the same input bindings as the Render view.

The Project Assets window now incorporates an image and an object preview. Click the Preview button next to the Refresh button to show the previews.

Menus which list all the objects and shaders in a project, such as the "Select Object or Shader" submenu, now show node names correctly instead of always capitalising the first letter etc.

Menus which list all the objects in a project, such as the "Select Object or Shader" submenu, now show a colour chip showing the preview colour for the object, as long as it's enabled and not white.

Many parameters now have steppers/up-down arrows which increase and decrease values. Some parameters may still need to have the stepper increment adjusted. If there is anything which stands out as being odd please let us know.

Opening a project from the Open Recent menu item will now prompt you to save/discard changes if the current project is modified.

Mac only: Fixed a longstanding bug with lists where column headers could draw incorrectly when you scrolled a list.

Fixed a problem with the Colour Picker not appearing if it was last open on a monitor which has since been disconnected.

Mac only: Fixed a problem which would cause TG2 to crash on startup when the system language used a non-Roman alphabet.

Animation buttons for animated params now show a small coloured dot in the top left of their icon. This is mainly so that params without text fields can show when they're animated. The colour of the dot respects the Animated and Keyframed parameter text colours in the Interface Colours prefs.

Fixed a bug where newly created nodes could incorrectly display an animation icon in the network view (bug 428).

Mac only: Project and clip files can now be previewed using Quick Look on OS X. Windows Preview Handlers will be included in a future release.


IMPORT AND EXPORT

Camera Import tab has options for the rotation order of the camera that generated the chan file. During import, rotation values are converted from that rotation order into Terragen's native ZXY order. If the order is ZXY, no conversion is done to the rotation order.

Camera can export a Nuke Chan file (only in Professional Edition and Professional with Animation).

After selecting an import filename or export filename with a file dialog, camera asks if you want to import/export now.


ATMOSPHERE AND CLOUDS

Cloud Layer V2 has options to use a voxel buffer to optimise rendering in various ways. Only works properly when "localise" is enabled. (Only in Professional Edition and Professional with Animation.)

Cloud Layer V2 accepts functions to modulate direct light, enviro light and ambient light. The cloud node is now drawn wider because of the extra inputs.

"Number of samples" is now hidden on Cloud Layer V2. You should use the "Quality" parameter instead.

Cloud Layer render method defaults to 3D.


End of changes for 3.0.01.0 (Release).
